package cz.vutbr.fit.gja.chatserver;

import java.io.IOException;
import java.io.PrintStream;
import java.net.ServerSocket;
import java.net.Socket;

public class Server {

  private static ServerSocket serverSocket = null;
  private static Socket clientSocket = null;

  private static final int maxClientsCount = 10;
  private static final ClientThread[] threads = new ClientThread[maxClientsCount];

  public static void main(String args[]) {

    try {
      serverSocket = new ServerSocket(1234);
      System.out.println("Listening on port 1234.");
    } catch (IOException e) {
      System.out.println(e);
    }

    while (true) {
      try {
        clientSocket = serverSocket.accept();
        int i = 0;
        for (i = 0; i < maxClientsCount; i++) {
          if (threads[i] == null) {
            (threads[i] = new ClientThread(clientSocket, threads)).start();
            break;
          }
        }
        PrintStream os = new PrintStream(clientSocket.getOutputStream());
        if (i == maxClientsCount) {

          os.println("Server too busy. Try later.");
          os.close();
          clientSocket.close();
        }

      } catch (IOException e) {
        System.out.println(e);
      }
    }
  }
}
